#include<iostream>
#include<iomanip>
using namespace std;
bool isAYear(const string& yearString)
{
  for(int i=0;i<yearString.length();i++)
  {
    if((yearString[i])=='-')
      if(i!=0)
        return false;
    if(!isdigit(yearString[i]))
      if((yearString[i])!='-')
        return false;
  }
  int year=atoi(yearString.c_str());
  if(year==0)
    return false;
  if(year<-999999999||year>999999999)
    return false;

  return true;
}
bool isAMonth(const string& monthString)
{
  for(int i=0;i<monthString.length();i++)
  {
    if(!isdigit(monthString[i]))
      return false;
  }
  int month=atoi(monthString.c_str());
  if(month>0&&month<13)
    return true;

  return false;
}
bool isADayNum(const string& dayNumString,int year,int month,bool negative)
{
  for(int i=0;i<dayNumString.length();i++)
  {
    if(!isdigit(dayNumString[i]))
      return false;
  }
  int dayNum=atoi(dayNumString.c_str());

  if(month==1&&dayNum>0&&dayNum<32)
    return true;
  else if(negative==true&&month==2&&((year-3)%4)==0&&dayNum>0&&dayNum<30)
    return true;
  else if(negative==true&&month==2&&((year-3)%4)!=0&&dayNum>0&&dayNum<29)
    return true;
  else if(negative==false&&month==2&&(year%4)==0&&dayNum>0&&dayNum<30)
    return true;
  else if(negative==false&&month==2&&(year%4)!=0&&dayNum>0&&dayNum<29)
    return true;
  else if(month==3&&dayNum>0&&dayNum<32)
    return true;
  else if(month==4&&dayNum>0&&dayNum<31)
    return true;
  else if(month==5&&dayNum>0&&dayNum<32)
    return true;
  else if(month==6&&dayNum>0&&dayNum<31)
    return true;
  else if(month==7&&dayNum>0&&dayNum<32)
    return true;
  else if(month==8&&dayNum>0&&dayNum<32)
    return true;
  else if(month==9&&dayNum>0&&dayNum<31)
    return true;
  else if(month==10&&dayNum>0&&dayNum<32)
    return true;
  else if(month==11&&dayNum>0&&dayNum<31)
    return true;
  else if(month==12&&dayNum>0&&dayNum<32)
    return true;

  return false;
}
bool isADate(const string& date)
{
  bool negative=false;

  if(date.substr(2,1)!="/" || date.substr(5,1)!="/")
    return false;
  if(!isAYear(date.substr(6,(date.length()-6))))
    return false;
  if(!isAMonth(date.substr(0,2)))
    return false;
  string yearString=date.substr(6,(date.length()-6)),monthString=date.substr(0,2);
  int year=atoi(yearString.c_str()),month=atoi(monthString.c_str());
  if((yearString.substr(0,1))=="-")
    negative=true;

  if(!isADayNum(date.substr(3,2),year,month,negative))
    return false;
  if((date[2])!='/'&&(date[5])!='/')
    return false;

  return true;
}
